//
//  Month.m
//  YKCalendar
//
//  Created by KOYAMA Yoshiaki on Thu Oct 09 2003.
//  Copyright (c) 2003 KOYAMA Yoshiaki. All rights reserved.
//

#import "Month.h"

@implementation Month

// 
- (id)init {

    self = [super init];
    [self initCalendar];

    return self;
}

// ϐ̏B
- (void)initCalendar {
    NSCalendarDate *calendar;
    int year, month, day, week;

//    NSLog(@"%@", [calendar description]);

    calendar = [NSCalendarDate calendarDate];
    year = [calendar yearOfCommonEra];
    month = [calendar monthOfYear];
    day = [calendar dayOfMonth]; 
    week = [calendar dayOfWeek];

    _calendar = [NSCalendarDate dateWithYear:year month:month day:1 hour:0 minute:0	second:0 timeZone:nil];

    _nowCalendar = calendar;

    [_calendar retain];
    [_nowCalendar retain];
    _arrayHoliday = [[NSMutableArray alloc] init];
}

// `B
- (void)drawMonth {
    [self setTextField];
    [self drawBack];
    [self printYoubi];
    [self drawOneMonth];
}

// wi̕`B
- (void)drawBack {
    NSRect rect;

    rect = [_calendarView bounds];
    [[NSColor lightGrayColor] set];
    NSRectFill(rect);
}

// j̕`B
- (void)printYoubi {
    NSString *str, *cStr;
    NSBundle *bundle;
    NSScanner *scan;
    NSCharacterSet *set;
    BOOL flag = NO;
    NSMutableArray *array = [[NSMutableArray alloc] init];

    // {̗jǂݍށB
    bundle = [NSBundle mainBundle];
    str = [bundle localizedStringForKey:@"YOUBI" value:@"" table:nil];
    scan = [NSScanner scannerWithString:str];
    set = [NSCharacterSet characterSetWithCharactersInString:@" ,"];
    do {
        flag = [scan scanUpToCharactersFromSet:set intoString:&cStr];
        if (flag == YES) {
            [array addObject:cStr];
        }
//        flag = [scan scanCharactersFromSet:set intoString:nil];        
    } while (flag == YES);
    [self drawDay:array];
}

// ۂɗj̕`ȂB
- (void)drawDay:(NSMutableArray *)strings {
    NSMutableDictionary *dicAttr = [[NSMutableDictionary alloc] init];
    NSFont *fontAttr = [NSFont fontWithName: @"HiraKakuPro-W3" size:10];
    NSString *str;
    NSPoint pos;
    int i;

    pos = NSMakePoint(0,150 - 15);

    for (i=0;i<[strings count];i++) {
        str = [strings objectAtIndex:i];

        [dicAttr release];
        dicAttr = [[NSMutableDictionary alloc] init];
        if (i == 0) {
            [dicAttr setObject: [NSColor redColor] 		 		 		forKey:NSForegroundColorAttributeName];
        } else if (i == 6) {
            [dicAttr setObject: [NSColor blueColor] 		 		  		forKey:NSForegroundColorAttributeName];
        } else {
            [dicAttr setObject: [NSColor blackColor] 		 		  		forKey:NSForegroundColorAttributeName];
        }
        [dicAttr setObject: fontAttr forKey: NSFontAttributeName];

        pos.x = 20*i + 5*i + 10 ;
        [str drawAtPoint:pos withAttributes: dicAttr];
//        pos.y = 150 - 10*i - 10*i - 10;
    }
    
    [dicAttr release];
}

// Localizable.strings炻̌̏jf[^ǂݎB
- (void)makeHoliday {
    NSString *str, *cStr;
    NSBundle *bundle;
    NSScanner *scan;
    NSCharacterSet *set;
    BOOL flag = NO;
    NSString *mHoliday;
    int year, month;
    NSNumber *number;

    year = [_calendar yearOfCommonEra];
    month = [_calendar monthOfYear];

    [_arrayHoliday release];
    _arrayHoliday = [[NSMutableArray alloc] init];

    bundle = [NSBundle mainBundle];

    mHoliday= [NSString stringWithFormat:@"%02d%02d", year, month];
//    NSLog(@"%@", mHoliday);

    str = [bundle localizedStringForKey:mHoliday value:@"" table:nil];

//    NSLog(@"holiday [%@] :[%@]", mHoliday, str);
    if ([str isEqualToString:mHoliday] == YES) {
        return;
    }

    scan = [NSScanner scannerWithString:str];
    set = [NSCharacterSet characterSetWithCharactersInString:@" ,"];
    do {
        flag = [scan scanUpToCharactersFromSet:set intoString:&cStr];
        if (flag == YES) {
            number = [NSNumber numberWithInt:[cStr intValue]];        
            // j̓NSNumberɂĔzɊi[B
            [_arrayHoliday addObject:number];
//        NSLog(@"%@", number);
        }
    } while (flag == YES);
}

// jfB
- (BOOL)checkHoliday:(int)day {
    int i;
    NSNumber *dayNumber, *number;

    dayNumber = [NSNumber numberWithInt:day];        
    
    for (i=0; i<[_arrayHoliday count]; i++) {
        number = [_arrayHoliday objectAtIndex:i];
        if ([number isEqualToNumber:dayNumber] == YES) {
            return YES;
        }
    }    
    return NO;
}

// P̕`B
- (void)drawOneMonth {
    NSCalendarDate *calendar;
    int year, month, day, week, bMonth, height;
    BOOL holiday = NO;

    height = 1;
    year = [_calendar yearOfCommonEra];
    bMonth = month = [_calendar monthOfYear];
    day = [_calendar dayOfMonth]; 
    week = [_calendar dayOfWeek];

    [self makeHoliday];
    calendar = [NSCalendarDate dateWithYear:year month:month day:1 hour:0 minute:0 	second:0 timeZone:nil];
    do {
//        NSLog(@"%d %d %d %d", year, month, day, week);
        holiday = [self checkHoliday:day];
        [self drawDay:day :week :month :year :height :holiday];
        if (week == 6) {
            height++;
        }
        
        calendar = [calendar dateByAddingYears:0 months:0 days:1 hours:0 minutes:0 			seconds:0];
        year = [calendar yearOfCommonEra];
        month = [calendar monthOfYear];
        week = [calendar dayOfWeek];
        day = [calendar dayOfMonth]; 

    } while (bMonth == month);
}

// t`B
- (void)drawDay:(int)day :(int)week :(int)month :(int)year :(int)height :(BOOL)holiday {
    NSMutableDictionary *dicAttr = [[NSMutableDictionary alloc] init];
    NSFont *fontAttr = [NSFont fontWithName: @"HiraKakuPro-W3" size:10];
    NSString *str;
    NSString *dStr = @"  ";
    NSColor *color;
    NSPoint pos;
    NSNumber *number;
    int length,nowYear, nowWeek, nowMonth, nowDay;
    NSRange range;

    nowYear = [_nowCalendar yearOfCommonEra];
    nowMonth = [_nowCalendar monthOfYear];
    nowWeek = [_nowCalendar dayOfWeek];
    nowDay = [_nowCalendar dayOfMonth]; 

    pos = NSMakePoint(0,150 - 15 - height*20);
    if ((week == 0) || (holiday == YES)) {
        color = [NSColor redColor];
    } else if (week == 6) {
        color = [NSColor blueColor];
    } else {
        color = [NSColor blackColor];
    }

    if ((nowYear == year) && (nowMonth == month) && (nowDay == day)) {
        number = [NSNumber numberWithInt:1];
        [dicAttr setObject: number forKey: NSUnderlineStyleAttributeName];
//        color = [NSColor greenColor];
    }
    
    [dicAttr setObject: color  forKey: NSForegroundColorAttributeName];
    [dicAttr setObject: fontAttr forKey: NSFontAttributeName];

    str = [NSString stringWithFormat:@"%d", day];
    length = [str length];
    str = [dStr stringByAppendingString:str];

//    NSLog(@"[%@]", str);

    if (length == 1) {
        range.location = 0;
        range.length = 3;
    } else {
        length = [str length];
        range.location = length - 2;
        range.length = 2;
    }
    str = [str substringWithRange:range];

    pos.x = 20*week + 5*week + 5 ;
    [str drawAtPoint:pos withAttributes: dicAttr];
    
    [dicAttr release];
}

// NA̕\B
- (void)setTextField {
    int year, month;

    year = [_calendar yearOfCommonEra];
    month = [_calendar monthOfYear];

//NSLog(@"year %d month %d", year, month);

    [_year setIntValue:year];
    [_month setIntValue:month];
}

// ꃖOB
- (IBAction)backMonth:(id)sender {
    NSCalendarDate *calendar;
    unsigned count;
 
    count = [_calendar retainCount];
    calendar = [_calendar dateByAddingYears:0 months:-1 days:0 hours:0 minutes:0
                    seconds:0];
    if (count == 1) {
        [_calendar release];
    }

    _calendar = calendar;
    [_calendar retain];

    [_calendarView setNeedsDisplay:YES];

}

// PB
- (IBAction)nextMonth:(id)sender {
    NSCalendarDate *calendar;
    unsigned count;

    count = [_calendar retainCount];
    calendar = [_calendar dateByAddingYears:0 months:1 days:0 hours:0 minutes:0
                    seconds:0];
    if (count == 1) {
        [_calendar release];
    }

    _calendar = calendar;
    [_calendar retain];

    [_calendarView setNeedsDisplay:YES];

}

// B
- (IBAction)thisMonth:(id)sender {
    unsigned count;
    int year, month, day, week;

    count = [_calendar retainCount];
    if (count == 1) {
        [_calendar release];
    }

    year = [_nowCalendar yearOfCommonEra];
    month = [_nowCalendar monthOfYear];
    day = [_nowCalendar dayOfMonth]; 
    week = [_nowCalendar dayOfWeek];

    _calendar = [NSCalendarDate dateWithYear:year month:month day:1 hour:0 minute:0	second:0 timeZone:nil];

    [_calendar retain];

    [_calendarView setNeedsDisplay:YES];

}

@end
